#if !defined(__BLANKTEXTURE_H)
#define __BLANKTEXTURE_H

#include "Texture.h"

class BlankTexture : public Texture
{
public:

	void configure(const string &prefix, const string &subKey) { };
	bool apply(HDC hDC, int x, int y, int width, int height, int transparencyMode, int imageType) { return false; };
	bool applyAnim(HDC hDC, int x, int y, int width, int height, int transparencyMode, int imageType, int count) { return false; };

	bool isTransparencyNeeded() { return true; };
	bool isAlphaMapNeeded() { return false; };
};

#endif
