#if !defined(__XFONT_H)
#define __XFONT_H

class xFont
{
public:

	xFont();
	virtual ~xFont();

	void configure(const string &prefix, xFont *baseFont);
	void apply(HDC hDC, int left, int right, int top, int bottom, const string &text, int align, int vertAlign, StringList &labelHREFClickRegions, bool desktopLabel = false);
	POINT measure(HDC hDC, int left, int right, const string &text, int align, int vertAlign);

	void setShadow(bool shadow);
	void setColor(int aColor, bool shadow = false);

	int shadowX;
	int shadowY; 
	
private:

	string name;
	int height;
	int color;

	bool bold;
	bool italic;
	bool underline;
	bool lineBreak;

	int newlineSpace;

	bool smooth;

	bool textoutline;
	int textoutlineColor;

	bool shadow;
	int shadowColor;
};

#endif
